Package net.sf.saxon.expr.instruct

## Class SimpleNodeConstructor

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.SimpleNodeConstructor

- All Implemented Interfaces:
    `ExportAgent`, `TailCallReturner`, `Locatable`, `IdentityComparable`, `Traceable`
  Direct Known Subclasses:
    `AttributeCreator`, `Comment`, `NamespaceConstructor`, `ProcessingInstruction`, `ValueOf`

      public abstract class SimpleNodeConstructor
      extends Instruction

  Common superclass for XSLT instructions whose content template produces a text value: xsl:attribute, xsl:comment, xsl:processing-instruction, xsl:namespace, and xsl:text, and their XQuery equivalents

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Operand` | `selectOp` |

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SimpleNodeConstructor()` | Default constructor used by subclasses

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `allowExtractingCommonSubexpressions()` | Ask whether common subexpressions found in the operands of this expression can be extracted and evaluated outside the expression itself.
    `boolean` | `alwaysCreatesNewNodes()` | Ask whether it is guaranteed that every item in the result of this instruction is a newly created node
    `protected java.lang.String` | `checkContent​(java.lang.String data, XPathContext context)` | Check the content of the node, and adjust it if necessary.
    `int` | `computeCardinality()` | Get the cardinality of the sequence returned by evaluating this instruction
    `int` | `computeSpecialProperties()` | Get the static properties of this expression (other than its type).
    `Item` | `evaluateItem​(XPathContext context)` | Evaluate as an expression.
    `NodeName` | `evaluateNodeName​(XPathContext context)` | Run-time method to compute the name of the node being constructed.
    `Expression` | `getSelect()` | Get the select expression, that is the expression that computes the content of the constructed node.
    `java.lang.String` | `getStreamerName()` | Get the (partial) name of a class that supports streaming of this kind of expression
    `boolean` | `isLocal()` |
    `SequenceIterator` | `iterate​(XPathContext context)` | Return an Iterator to iterate over the values of a sequence.
    `abstract void` | `localTypeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Method to perform type-checking specific to the kind of instruction
    `boolean` | `mayCreateNewNodes()` | Ask whether this instruction creates new nodes.
    `java.lang.Iterable<Operand>` | `operands()` | Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `TailCall` | `processLeavingTail​(Outputter output, XPathContext context)` | Process this instruction
    `abstract void` | `processValue​(java.lang.CharSequence value, Outputter output, XPathContext context)` | Process the value of the node, to create the new node.
    `void` | `setSelect​(Expression select)` | Set the select expression: the value of this expression determines the string-value of the node
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | The typeCheck() method is called in XQuery, where node constructors are implemented as Expressions.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getExpressionName, getImplementationMethod, getInstructionNameCode, getItemType, getNetCost, getSourceLocator, isInstruction, isXSLT, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkedOperands, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeHashCode, computeStaticProperties, copy, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, export, getCardinality, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, toShortString, toString, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Field Detail

    - #### selectOp

          protected Operand selectOp

  - ### Constructor Detail

    - #### SimpleNodeConstructor

          public SimpleNodeConstructor()

      Default constructor used by subclasses

  - ### Method Detail

    - #### setSelect

          public void setSelect​(Expression select)

      Set the select expression: the value of this expression determines the string-value of the node
      Parameters:
        `select` - the expression that computes the string value of the node

    - #### getSelect

          public Expression getSelect()

      Get the select expression, that is the expression that computes the content of the constructed node. Note that this may correspond either to a select attribute or a contained sequence constructor in the case of XSLT; and in XQuery it corresponds to whatever expression is contained in the node constructpr.
      Returns:
        the expression used to compute the content of the node.

    - #### operands

          public java.lang.Iterable<Operand> operands()

      Description copied from class: `Expression`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation works off the results of iterateSubExpressions()

      If the expression is a Callable, then it is required that the order of the operands returned by this function is the same as the order of arguments supplied to the corresponding call() method.

      Specified by:
        `operands` in class `Instruction`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### mayCreateNewNodes

          public final boolean mayCreateNewNodes()

      Ask whether this instruction creates new nodes. This implementation returns true.
      Overrides:
        `mayCreateNewNodes` in class `Instruction`
      Returns:
        true if the instruction creates new nodes under some input conditions (or if it can't be proved that it doesn't)

    - #### alwaysCreatesNewNodes

          public boolean alwaysCreatesNewNodes()

      Ask whether it is guaranteed that every item in the result of this instruction is a newly created node
      Overrides:
        `alwaysCreatesNewNodes` in class `Instruction`
      Returns:
        true if result of the instruction is always either an empty sequence or a sequence consisting entirely of newly created nodes

    - #### computeCardinality

          public int computeCardinality()

      Get the cardinality of the sequence returned by evaluating this instruction
      Overrides:
        `computeCardinality` in class `Instruction`
      Returns:
        the static cardinality

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `Instruction`
      Returns:
        a set of flags indicating static properties of this expression

    - #### allowExtractingCommonSubexpressions

          public boolean allowExtractingCommonSubexpressions()

      Ask whether common subexpressions found in the operands of this expression can be extracted and evaluated outside the expression itself. The result is irrelevant in the case of operands evaluated with a different focus, which will never be extracted in this way, even if they have no focus dependency.
      Overrides:
        `allowExtractingCommonSubexpressions` in class `Expression`
      Returns:
        false for this kind of expression

    - #### localTypeCheck

          public abstract void localTypeCheck​(ExpressionVisitor visitor,
                                              ContextItemStaticInfo contextItemType)
                                       throws XPathException

      Method to perform type-checking specific to the kind of instruction
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of the context item
      Throws:
        `XPathException` - if a type error is detected

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      The typeCheck() method is called in XQuery, where node constructors are implemented as Expressions. In this case the required type for the select expression is a single string. param visitor an expression visitor
      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `contextInfo` - information about the dynamic context
        `visitor` - an expression visitor
      Returns:
        the rewritten expression
      Throws:
        `XPathException` - if any static errors are found in this expression or any of its children

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### getStreamerName

          public java.lang.String getStreamerName()

      Get the (partial) name of a class that supports streaming of this kind of expression
      Overrides:
        `getStreamerName` in class `Expression`
      Returns:
        the partial name of a class that can be instantiated to provide streaming support in Saxon-EE, or null if there is no such class

    - #### processLeavingTail

          public TailCall processLeavingTail​(Outputter output,
                                             XPathContext context)
                                      throws XPathException

      Process this instruction
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Specified by:
        `processLeavingTail` in class `Instruction`
      Parameters:
        `output` - the destination for the result
        `context` - the dynamic context of the transformation
      Returns:
        a TailCall to be executed by the caller, always null for this instruction
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### processValue

          public abstract void processValue​(java.lang.CharSequence value,
                                            Outputter output,
                                            XPathContext context)
                                     throws XPathException

      Process the value of the node, to create the new node.
      Parameters:
        `value` - the string value of the new node
        `output` - the destination for the result
        `context` - the dynamic evaluation context
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### evaluateItem

          public Item evaluateItem​(XPathContext context)
                            throws XPathException

      Evaluate as an expression.
      Overrides:
        `evaluateItem` in class `Instruction`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### checkContent

          protected java.lang.String checkContent​(java.lang.String data,
                                                  XPathContext context)
                                           throws XPathException

      Check the content of the node, and adjust it if necessary. The checks depend on the node kind.
      Parameters:
        `data` - the supplied content
        `context` - the dynamic context
      Returns:
        the original content, unless adjustments are needed
      Throws:
        `XPathException` - if the content is invalid

    - #### evaluateNodeName

          public NodeName evaluateNodeName​(XPathContext context)
                                    throws XPathException

      Run-time method to compute the name of the node being constructed. This is overridden for nodes that have a name. The default implementation returns null, which is suitable for unnamed nodes such as comments
      Parameters:
        `context` - the XPath dynamic evaluation context
      Returns:
        the name pool nameCode identifying the name of the constructed node
      Throws:
        `XPathException` - if any failure occurs

    - #### iterate

          public SequenceIterator iterate​(XPathContext context)
                                   throws XPathException

      Description copied from class: `Instruction`
      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Overrides:
        `iterate` in class `Instruction`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### isLocal

          public boolean isLocal()